/*
 * Copyright 2013-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You may not use this file except in compliance with
 * the License. A copy of the License is located at
 * 
 * http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions
 * and limitations under the License.
 */
package com.amazonaws.services.simpleemail.model.transform;

import java.util.ArrayList;

import javax.xml.stream.events.XMLEvent;
import javax.annotation.Generated;

import com.amazonaws.services.simpleemail.model.*;
import com.amazonaws.transform.Unmarshaller;

import com.amazonaws.transform.StaxUnmarshallerContext;
import com.amazonaws.transform.SimpleTypeStaxUnmarshallers.*;

/**
 * ReceiptRule StAX Unmarshaller
 */

@Generated("com.amazonaws:aws-java-sdk-code-generator")
public class ReceiptRuleStaxUnmarshaller implements Unmarshaller<ReceiptRule, StaxUnmarshallerContext> {

    public ReceiptRule unmarshall(StaxUnmarshallerContext context) throws Exception {
        ReceiptRule receiptRule = new ReceiptRule();
        int originalDepth = context.getCurrentDepth();
        int targetDepth = originalDepth + 1;

        if (context.isStartOfDocument())
            targetDepth += 1;

        while (true) {
            XMLEvent xmlEvent = context.nextEvent();
            if (xmlEvent.isEndDocument())
                return receiptRule;

            if (xmlEvent.isAttribute() || xmlEvent.isStartElement()) {

                if (context.testExpression("Name", targetDepth)) {
                    receiptRule.setName(StringStaxUnmarshaller.getInstance().unmarshall(context));
                    continue;
                }

                if (context.testExpression("Enabled", targetDepth)) {
                    receiptRule.setEnabled(BooleanStaxUnmarshaller.getInstance().unmarshall(context));
                    continue;
                }

                if (context.testExpression("TlsPolicy", targetDepth)) {
                    receiptRule.setTlsPolicy(StringStaxUnmarshaller.getInstance().unmarshall(context));
                    continue;
                }

                if (context.testExpression("Recipients", targetDepth)) {
                    receiptRule.withRecipients(new ArrayList<String>());
                    continue;
                }

                if (context.testExpression("Recipients/member", targetDepth)) {
                    receiptRule.withRecipients(StringStaxUnmarshaller.getInstance().unmarshall(context));
                    continue;
                }

                if (context.testExpression("Actions", targetDepth)) {
                    receiptRule.withActions(new ArrayList<ReceiptAction>());
                    continue;
                }

                if (context.testExpression("Actions/member", targetDepth)) {
                    receiptRule.withActions(ReceiptActionStaxUnmarshaller.getInstance().unmarshall(context));
                    continue;
                }

                if (context.testExpression("ScanEnabled", targetDepth)) {
                    receiptRule.setScanEnabled(BooleanStaxUnmarshaller.getInstance().unmarshall(context));
                    continue;
                }
            } else if (xmlEvent.isEndElement()) {
                if (context.getCurrentDepth() < originalDepth) {
                    return receiptRule;
                }
            }
        }
    }

    private static ReceiptRuleStaxUnmarshaller instance;

    public static ReceiptRuleStaxUnmarshaller getInstance() {
        if (instance == null)
            instance = new ReceiptRuleStaxUnmarshaller();
        return instance;
    }
}
